/* LEARN39.REX -- draw border, wait for user to hit key */

CALL ScrClear               /* clear the screen */
CALL Cursor 3,5             /* cursor in row 3 column 5 */

CALL Frame 1,1,25,80        /* draw the frame */

CALL InKey                  /* wait for user to hit key */
CALL ScrClear               /* clear the screen         */

EXIT

Frame: PROCEDURE
/* draw border with IBM double-line extended characters */

   ARG urow, ucol, lrow, lcol  /* upper left & lower right */
                               /* coordinates of frame     */

   horiz  = D2C(205)     /* ASCII 205: horizontal border   */
   vert   = D2C(186)     /* ASCII 186: vertical border     */
   tleft  = D2C(201)     /* ASCII 201: top left corner     */
   tright = D2C(187)     /* ASCII 187: top right corner    */
   bleft  = D2C(200)     /* ASCII 200: bottom left corner  */
   bright = D2C(188)     /* ASCII 188: bottom right corner */
   width = lcol - ucol - 1   /* width of horizontal border */
   hcol  = ucol + 1          /* start of horizontal border */

   /* draw top of frame */
   CALL ScrWrite urow, ucol, tleft
   CALL ScrWrite urow, hcol,, width, horiz
   CALL ScrWrite urow, lcol, tright

   /* draw sides of frame */
   DO row = urow+1 TO lrow-1
      CALL ScrWrite row, ucol, vert
      CALL ScrWrite row, lcol, vert
      END

   /* draw bottom of frame */
   CALL ScrWrite lrow, ucol, bleft
   CALL ScrWrite lrow, hcol,, width, horiz
   CALL ScrWrite lrow, lcol, bright
   RETURN

/* END LEARN39.REX */
