/*********************************************/
/* traverse tree of directories, starting at */
/* current directory, issuing a specified    */
/* command in each directory.                */
/* for example, 'rexx traverse erase *.bak'  */
/*********************************************/

parse arg command
savecd = doscd()
directory = savecd
if right(directory,1) = '\' then
   directory = left(directory, length(directory) - 1)
call tree directory, command
call doschdir savecd
exit


tree: procedure
  parse arg directory, command
  if directory = '' then
     say '--> \'
  else
     say '-->' directory
  call doschdir directory
  command
  name = dosdir(directory'\*.*','n','d','d')
  position = dosdirpos()
  do while name <> ''
    if name <> '.' & name <> '..' then
       call tree directory'\'name, command
    name = dosdir(,'n','d','d',position)
    position = dosdirpos()
   end
  return
